diff -urNp linux-2.6.32.24/drivers/char/random.c linux-2.6.32.24/drivers/char/random.c
--- linux-2.6.32.24/drivers/char/random.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/char/random.c	2010-09-04 15:54:52.000000000 -0400
@@ -254,8 +254,13 @@
 /*
  * Configuration information
  */
+#ifdef CONFIG_GRKERNSEC_RANDNET
+#define INPUT_POOL_WORDS 512
+#define OUTPUT_POOL_WORDS 128
+#else
 #define INPUT_POOL_WORDS 128
 #define OUTPUT_POOL_WORDS 32
+#endif
 #define SEC_XFER_SIZE 512
 
 /*
@@ -292,10 +297,17 @@ static struct poolinfo {
 	int poolwords;
 	int tap1, tap2, tap3, tap4, tap5;
 } poolinfo_table[] = {
+#ifdef CONFIG_GRKERNSEC_RANDNET
+	/* x^512 + x^411 + x^308 + x^208 +x^104 + x + 1 -- 225 */
+	{ 512,	411,	308,	208,	104,	1 },
+	/* x^128 + x^103 + x^76 + x^51 + x^25 + x + 1 -- 105 */
+	{ 128,	103,	76,	51,	25,	1 },
+#else
 	/* x^128 + x^103 + x^76 + x^51 +x^25 + x + 1 -- 105 */
 	{ 128,	103,	76,	51,	25,	1 },
 	/* x^32 + x^26 + x^20 + x^14 + x^7 + x + 1 -- 15 */
 	{ 32,	26,	20,	14,	7,	1 },
+#endif
 #if 0
 	/* x^2048 + x^1638 + x^1231 + x^819 + x^411 + x + 1  -- 115 */
 	{ 2048,	1638,	1231,	819,	411,	1 },
@@ -1209,7 +1221,7 @@ EXPORT_SYMBOL(generate_random_uuid);
 #include <linux/sysctl.h>
 
 static int min_read_thresh = 8, min_write_thresh;
-static int max_read_thresh = INPUT_POOL_WORDS * 32;
+static int max_read_thresh = OUTPUT_POOL_WORDS * 32;
 static int max_write_thresh = INPUT_POOL_WORDS * 32;
 static char sysctl_bootid[16];
 
diff -urNp linux-2.6.32.24/drivers/char/sonypi.c linux-2.6.32.24/drivers/char/sonypi.c
--- linux-2.6.32.24/drivers/char/sonypi.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/char/sonypi.c	2010-09-04 15:54:52.000000000 -0400
@@ -491,7 +491,7 @@ static struct sonypi_device {
 	spinlock_t fifo_lock;
 	wait_queue_head_t fifo_proc_list;
 	struct fasync_struct *fifo_async;
-	int open_count;
+	atomic_t open_count;
 	int model;
 	struct input_dev *input_jog_dev;
 	struct input_dev *input_key_dev;
@@ -895,7 +895,7 @@ static int sonypi_misc_fasync(int fd, st
 static int sonypi_misc_release(struct inode *inode, struct file *file)
 {
 	mutex_lock(&sonypi_device.lock);
-	sonypi_device.open_count--;
+	atomic_dec(&sonypi_device.open_count);
 	mutex_unlock(&sonypi_device.lock);
 	return 0;
 }
@@ -905,9 +905,9 @@ static int sonypi_misc_open(struct inode
 	lock_kernel();
 	mutex_lock(&sonypi_device.lock);
 	/* Flush input queue on first open */
-	if (!sonypi_device.open_count)
+	if (!atomic_read(&sonypi_device.open_count))
 		kfifo_reset(sonypi_device.fifo);
-	sonypi_device.open_count++;
+	atomic_inc(&sonypi_device.open_count);
 	mutex_unlock(&sonypi_device.lock);
 	unlock_kernel();
 	return 0;
diff -urNp linux-2.6.32.24/drivers/char/tpm/tpm_bios.c linux-2.6.32.24/drivers/char/tpm/tpm_bios.c
--- linux-2.6.32.24/drivers/char/tpm/tpm_bios.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/char/tpm/tpm_bios.c	2010-09-04 15:54:52.000000000 -0400
@@ -172,7 +172,7 @@ static void *tpm_bios_measurements_start
 	event = addr;
 
 	if ((event->event_type == 0 && event->event_size == 0) ||
-	    ((addr + sizeof(struct tcpa_event) + event->event_size) >= limit))
+	    (event->event_size >= limit - addr - sizeof(struct tcpa_event)))
 		return NULL;
 
 	return addr;
@@ -197,7 +197,7 @@ static void *tpm_bios_measurements_next(
 		return NULL;
 
 	if ((event->event_type == 0 && event->event_size == 0) ||
-	    ((v + sizeof(struct tcpa_event) + event->event_size) >= limit))
+	    (event->event_size >= limit - v - sizeof(struct tcpa_event)))
 		return NULL;
 
 	(*pos)++;
@@ -290,7 +290,8 @@ static int tpm_binary_bios_measurements_
 	int i;
 
 	for (i = 0; i < sizeof(struct tcpa_event) + event->event_size; i++)
-		seq_putc(m, data[i]);
+		if (!seq_putc(m, data[i]))
+			return -EFAULT;
 
 	return 0;
 }
@@ -409,6 +410,11 @@ static int read_log(struct tpm_bios_log 
 	log->bios_event_log_end = log->bios_event_log + len;
 
 	virt = acpi_os_map_memory(start, len);
+	if (!virt) {
+		kfree(log->bios_event_log);
+		log->bios_event_log = NULL;
+		return -EFAULT;
+	}
 
 	memcpy(log->bios_event_log, virt, len);
 
diff -urNp linux-2.6.32.24/drivers/char/tty_io.c linux-2.6.32.24/drivers/char/tty_io.c
--- linux-2.6.32.24/drivers/char/tty_io.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/char/tty_io.c	2010-09-04 15:54:52.000000000 -0400
@@ -136,21 +136,10 @@ LIST_HEAD(tty_drivers);			/* linked list
 DEFINE_MUTEX(tty_mutex);
 EXPORT_SYMBOL(tty_mutex);
 
-static ssize_t tty_read(struct file *, char __user *, size_t, loff_t *);
-static ssize_t tty_write(struct file *, const char __user *, size_t, loff_t *);
 ssize_t redirected_tty_write(struct file *, const char __user *,
 							size_t, loff_t *);
-static unsigned int tty_poll(struct file *, poll_table *);
 static int tty_open(struct inode *, struct file *);
-static int tty_release(struct inode *, struct file *);
 long tty_ioctl(struct file *file, unsigned int cmd, unsigned long arg);
-#ifdef CONFIG_COMPAT
-static long tty_compat_ioctl(struct file *file, unsigned int cmd,
-				unsigned long arg);
-#else
-#define tty_compat_ioctl NULL
-#endif
-static int tty_fasync(int fd, struct file *filp, int on);
 static void release_tty(struct tty_struct *tty, int idx);
 static void __proc_set_tty(struct task_struct *tsk, struct tty_struct *tty);
 static void proc_set_tty(struct task_struct *tsk, struct tty_struct *tty);
@@ -870,7 +859,7 @@ EXPORT_SYMBOL(start_tty);
  *	read calls may be outstanding in parallel.
  */
 
-static ssize_t tty_read(struct file *file, char __user *buf, size_t count,
+ssize_t tty_read(struct file *file, char __user *buf, size_t count,
 			loff_t *ppos)
 {
 	int i;
@@ -898,6 +887,8 @@ static ssize_t tty_read(struct file *fil
 	return i;
 }
 
+EXPORT_SYMBOL(tty_read);
+
 void tty_write_unlock(struct tty_struct *tty)
 {
 	mutex_unlock(&tty->atomic_write_lock);
@@ -1045,7 +1036,7 @@ void tty_write_message(struct tty_struct
  *	write method will not be invoked in parallel for each device.
  */
 
-static ssize_t tty_write(struct file *file, const char __user *buf,
+ssize_t tty_write(struct file *file, const char __user *buf,
 						size_t count, loff_t *ppos)
 {
 	struct tty_struct *tty;
@@ -1072,6 +1063,8 @@ static ssize_t tty_write(struct file *fi
 	return ret;
 }
 
+EXPORT_SYMBOL(tty_write);
+
 ssize_t redirected_tty_write(struct file *file, const char __user *buf,
 						size_t count, loff_t *ppos)
 {
@@ -1867,7 +1860,7 @@ static int tty_open(struct inode *inode,
  *		Takes bkl. See tty_release_dev
  */
 
-static int tty_release(struct inode *inode, struct file *filp)
+int tty_release(struct inode *inode, struct file *filp)
 {
 	lock_kernel();
 	tty_release_dev(filp);
@@ -1875,6 +1868,8 @@ static int tty_release(struct inode *ino
 	return 0;
 }
 
+EXPORT_SYMBOL(tty_release);
+
 /**
  *	tty_poll	-	check tty status
  *	@filp: file being polled
@@ -1887,7 +1882,7 @@ static int tty_release(struct inode *ino
  *	may be re-entered freely by other callers.
  */
 
-static unsigned int tty_poll(struct file *filp, poll_table *wait)
+unsigned int tty_poll(struct file *filp, poll_table *wait)
 {
 	struct tty_struct *tty;
 	struct tty_ldisc *ld;
@@ -1904,7 +1899,9 @@ static unsigned int tty_poll(struct file
 	return ret;
 }
 
-static int tty_fasync(int fd, struct file *filp, int on)
+EXPORT_SYMBOL(tty_poll);
+
+int tty_fasync(int fd, struct file *filp, int on)
 {
 	struct tty_struct *tty;
 	unsigned long flags;
@@ -1948,6 +1945,8 @@ out:
 	return retval;
 }
 
+EXPORT_SYMBOL(tty_fasync);
+
 /**
  *	tiocsti			-	fake input character
  *	@tty: tty to fake input into
@@ -2582,8 +2581,10 @@ long tty_ioctl(struct file *file, unsign
 	return retval;
 }
 
+EXPORT_SYMBOL(tty_ioctl);
+
 #ifdef CONFIG_COMPAT
-static long tty_compat_ioctl(struct file *file, unsigned int cmd,
+long tty_compat_ioctl(struct file *file, unsigned int cmd,
 				unsigned long arg)
 {
 	struct inode *inode = file->f_dentry->d_inode;
@@ -2607,6 +2608,8 @@ static long tty_compat_ioctl(struct file
 
 	return retval;
 }
+
+EXPORT_SYMBOL(tty_compat_ioctl);
 #endif
 
 /*
@@ -3050,11 +3053,6 @@ struct tty_struct *get_current_tty(void)
 }
 EXPORT_SYMBOL_GPL(get_current_tty);
 
-void tty_default_fops(struct file_operations *fops)
-{
-	*fops = tty_fops;
-}
-
 /*
  * Initialize the console device. This is called *early*, so
  * we can't necessarily depend on lots of kernel help here.
diff -urNp linux-2.6.32.24/drivers/char/tty_ldisc.c linux-2.6.32.24/drivers/char/tty_ldisc.c
--- linux-2.6.32.24/drivers/char/tty_ldisc.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/char/tty_ldisc.c	2010-09-04 15:54:52.000000000 -0400
@@ -73,7 +73,7 @@ static void put_ldisc(struct tty_ldisc *
 	if (atomic_dec_and_lock(&ld->users, &tty_ldisc_lock)) {
 		struct tty_ldisc_ops *ldo = ld->ops;
 
-		ldo->refcount--;
+		atomic_dec(&ldo->refcount);
 		module_put(ldo->owner);
 		spin_unlock_irqrestore(&tty_ldisc_lock, flags);
 
@@ -107,7 +107,7 @@ int tty_register_ldisc(int disc, struct 
 	spin_lock_irqsave(&tty_ldisc_lock, flags);
 	tty_ldiscs[disc] = new_ldisc;
 	new_ldisc->num = disc;
-	new_ldisc->refcount = 0;
+	atomic_set(&new_ldisc->refcount, 0);
 	spin_unlock_irqrestore(&tty_ldisc_lock, flags);
 
 	return ret;
@@ -135,7 +135,7 @@ int tty_unregister_ldisc(int disc)
 		return -EINVAL;
 
 	spin_lock_irqsave(&tty_ldisc_lock, flags);
-	if (tty_ldiscs[disc]->refcount)
+	if (atomic_read(&tty_ldiscs[disc]->refcount))
 		ret = -EBUSY;
 	else
 		tty_ldiscs[disc] = NULL;
@@ -156,7 +156,7 @@ static struct tty_ldisc_ops *get_ldops(i
 	if (ldops) {
 		ret = ERR_PTR(-EAGAIN);
 		if (try_module_get(ldops->owner)) {
-			ldops->refcount++;
+			atomic_inc(&ldops->refcount);
 			ret = ldops;
 		}
 	}
@@ -169,7 +169,7 @@ static void put_ldops(struct tty_ldisc_o
 	unsigned long flags;
 
 	spin_lock_irqsave(&tty_ldisc_lock, flags);
-	ldops->refcount--;
+	atomic_dec(&ldops->refcount);
 	module_put(ldops->owner);
 	spin_unlock_irqrestore(&tty_ldisc_lock, flags);
 }
diff -urNp linux-2.6.32.24/drivers/char/virtio_console.c linux-2.6.32.24/drivers/char/virtio_console.c
--- linux-2.6.32.24/drivers/char/virtio_console.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/char/virtio_console.c	2010-09-04 15:54:52.000000000 -0400
@@ -44,6 +44,7 @@ static unsigned int in_len;
 static char *in, *inbuf;
 
 /* The operations for our console. */
+/* cannot be const */
 static struct hv_ops virtio_cons;
 
 /* The hvc device */
diff -urNp linux-2.6.32.24/drivers/cpufreq/cpufreq.c linux-2.6.32.24/drivers/cpufreq/cpufreq.c
--- linux-2.6.32.24/drivers/cpufreq/cpufreq.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/cpufreq/cpufreq.c	2010-09-04 15:54:52.000000000 -0400
@@ -750,7 +750,7 @@ static void cpufreq_sysfs_release(struct
 	complete(&policy->kobj_unregister);
 }
 
-static struct sysfs_ops sysfs_ops = {
+static const struct sysfs_ops sysfs_ops = {
 	.show	= show,
 	.store	= store,
 };
diff -urNp linux-2.6.32.24/drivers/cpuidle/sysfs.c linux-2.6.32.24/drivers/cpuidle/sysfs.c
--- linux-2.6.32.24/drivers/cpuidle/sysfs.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/cpuidle/sysfs.c	2010-09-04 15:54:52.000000000 -0400
@@ -191,7 +191,7 @@ static ssize_t cpuidle_store(struct kobj
 	return ret;
 }
 
-static struct sysfs_ops cpuidle_sysfs_ops = {
+static const struct sysfs_ops cpuidle_sysfs_ops = {
 	.show = cpuidle_show,
 	.store = cpuidle_store,
 };
@@ -277,7 +277,7 @@ static ssize_t cpuidle_state_show(struct
 	return ret;
 }
 
-static struct sysfs_ops cpuidle_state_sysfs_ops = {
+static const struct sysfs_ops cpuidle_state_sysfs_ops = {
 	.show = cpuidle_state_show,
 };
 
@@ -294,7 +294,7 @@ static struct kobj_type ktype_state_cpui
 	.release = cpuidle_state_sysfs_release,
 };
 
-static void inline cpuidle_free_state_kobj(struct cpuidle_device *device, int i)
+static inline void cpuidle_free_state_kobj(struct cpuidle_device *device, int i)
 {
 	kobject_put(&device->kobjs[i]->kobj);
 	wait_for_completion(&device->kobjs[i]->kobj_unregister);
diff -urNp linux-2.6.32.24/drivers/dma/ioat/dma.c linux-2.6.32.24/drivers/dma/ioat/dma.c
--- linux-2.6.32.24/drivers/dma/ioat/dma.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/dma/ioat/dma.c	2010-09-04 15:54:52.000000000 -0400
@@ -1146,7 +1146,7 @@ ioat_attr_show(struct kobject *kobj, str
 	return entry->show(&chan->common, page);
 }
 
-struct sysfs_ops ioat_sysfs_ops = {
+const struct sysfs_ops ioat_sysfs_ops = {
 	.show	= ioat_attr_show,
 };
 
diff -urNp linux-2.6.32.24/drivers/dma/ioat/dma.h linux-2.6.32.24/drivers/dma/ioat/dma.h
--- linux-2.6.32.24/drivers/dma/ioat/dma.h	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/dma/ioat/dma.h	2010-09-04 15:54:52.000000000 -0400
@@ -347,7 +347,7 @@ bool ioat_cleanup_preamble(struct ioat_c
 			   unsigned long *phys_complete);
 void ioat_kobject_add(struct ioatdma_device *device, struct kobj_type *type);
 void ioat_kobject_del(struct ioatdma_device *device);
-extern struct sysfs_ops ioat_sysfs_ops;
+extern const struct sysfs_ops ioat_sysfs_ops;
 extern struct ioat_sysfs_entry ioat_version_attr;
 extern struct ioat_sysfs_entry ioat_cap_attr;
 #endif /* IOATDMA_H */
diff -urNp linux-2.6.32.24/drivers/edac/edac_core.h linux-2.6.32.24/drivers/edac/edac_core.h
--- linux-2.6.32.24/drivers/edac/edac_core.h	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/edac/edac_core.h	2010-09-04 15:54:52.000000000 -0400
@@ -99,11 +99,11 @@ extern int edac_debug_level;
 
 #else				/* !CONFIG_EDAC_DEBUG */
 
-#define debugf0( ... )
-#define debugf1( ... )
-#define debugf2( ... )
-#define debugf3( ... )
-#define debugf4( ... )
+#define debugf0( ... ) do {} while (0)
+#define debugf1( ... ) do {} while (0)
+#define debugf2( ... ) do {} while (0)
+#define debugf3( ... ) do {} while (0)
+#define debugf4( ... ) do {} while (0)
 
 #endif				/* !CONFIG_EDAC_DEBUG */
 
diff -urNp linux-2.6.32.24/drivers/edac/edac_device_sysfs.c linux-2.6.32.24/drivers/edac/edac_device_sysfs.c
--- linux-2.6.32.24/drivers/edac/edac_device_sysfs.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/edac/edac_device_sysfs.c	2010-09-04 15:54:52.000000000 -0400
@@ -137,7 +137,7 @@ static ssize_t edac_dev_ctl_info_store(s
 }
 
 /* edac_dev file operations for an 'ctl_info' */
-static struct sysfs_ops device_ctl_info_ops = {
+static const struct sysfs_ops device_ctl_info_ops = {
 	.show = edac_dev_ctl_info_show,
 	.store = edac_dev_ctl_info_store
 };
@@ -373,7 +373,7 @@ static ssize_t edac_dev_instance_store(s
 }
 
 /* edac_dev file operations for an 'instance' */
-static struct sysfs_ops device_instance_ops = {
+static const struct sysfs_ops device_instance_ops = {
 	.show = edac_dev_instance_show,
 	.store = edac_dev_instance_store
 };
@@ -476,7 +476,7 @@ static ssize_t edac_dev_block_store(stru
 }
 
 /* edac_dev file operations for a 'block' */
-static struct sysfs_ops device_block_ops = {
+static const struct sysfs_ops device_block_ops = {
 	.show = edac_dev_block_show,
 	.store = edac_dev_block_store
 };
diff -urNp linux-2.6.32.24/drivers/edac/edac_mc_sysfs.c linux-2.6.32.24/drivers/edac/edac_mc_sysfs.c
--- linux-2.6.32.24/drivers/edac/edac_mc_sysfs.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/edac/edac_mc_sysfs.c	2010-09-04 15:54:52.000000000 -0400
@@ -245,7 +245,7 @@ static ssize_t csrowdev_store(struct kob
 	return -EIO;
 }
 
-static struct sysfs_ops csrowfs_ops = {
+static const struct sysfs_ops csrowfs_ops = {
 	.show = csrowdev_show,
 	.store = csrowdev_store
 };
@@ -575,7 +575,7 @@ static ssize_t mcidev_store(struct kobje
 }
 
 /* Intermediate show/store table */
-static struct sysfs_ops mci_ops = {
+static const struct sysfs_ops mci_ops = {
 	.show = mcidev_show,
 	.store = mcidev_store
 };
diff -urNp linux-2.6.32.24/drivers/edac/edac_pci_sysfs.c linux-2.6.32.24/drivers/edac/edac_pci_sysfs.c
--- linux-2.6.32.24/drivers/edac/edac_pci_sysfs.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/edac/edac_pci_sysfs.c	2010-09-04 15:54:52.000000000 -0400
@@ -121,7 +121,7 @@ static ssize_t edac_pci_instance_store(s
 }
 
 /* fs_ops table */
-static struct sysfs_ops pci_instance_ops = {
+static const struct sysfs_ops pci_instance_ops = {
 	.show = edac_pci_instance_show,
 	.store = edac_pci_instance_store
 };
@@ -261,7 +261,7 @@ static ssize_t edac_pci_dev_store(struct
 	return -EIO;
 }
 
-static struct sysfs_ops edac_pci_sysfs_ops = {
+static const struct sysfs_ops edac_pci_sysfs_ops = {
 	.show = edac_pci_dev_show,
 	.store = edac_pci_dev_store
 };
diff -urNp linux-2.6.32.24/drivers/firewire/core-cdev.c linux-2.6.32.24/drivers/firewire/core-cdev.c
--- linux-2.6.32.24/drivers/firewire/core-cdev.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/firewire/core-cdev.c	2010-09-04 15:54:52.000000000 -0400
@@ -1141,8 +1141,7 @@ static int init_iso_resource(struct clie
 	int ret;
 
 	if ((request->channels == 0 && request->bandwidth == 0) ||
-	    request->bandwidth > BANDWIDTH_AVAILABLE_INITIAL ||
-	    request->bandwidth < 0)
+	    request->bandwidth > BANDWIDTH_AVAILABLE_INITIAL)
 		return -EINVAL;
 
 	r  = kmalloc(sizeof(*r), GFP_KERNEL);
diff -urNp linux-2.6.32.24/drivers/firmware/dmi_scan.c linux-2.6.32.24/drivers/firmware/dmi_scan.c
--- linux-2.6.32.24/drivers/firmware/dmi_scan.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/firmware/dmi_scan.c	2010-09-04 15:54:52.000000000 -0400
@@ -391,11 +391,6 @@ void __init dmi_scan_machine(void)
 		}
 	}
 	else {
-		/*
-		 * no iounmap() for that ioremap(); it would be a no-op, but
-		 * it's so early in setup that sucker gets confused into doing
-		 * what it shouldn't if we actually call it.
-		 */
 		p = dmi_ioremap(0xF0000, 0x10000);
 		if (p == NULL)
 			goto error;
diff -urNp linux-2.6.32.24/drivers/firmware/edd.c linux-2.6.32.24/drivers/firmware/edd.c
--- linux-2.6.32.24/drivers/firmware/edd.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/firmware/edd.c	2010-09-04 15:54:52.000000000 -0400
@@ -122,7 +122,7 @@ edd_attr_show(struct kobject * kobj, str
 	return ret;
 }
 
-static struct sysfs_ops edd_attr_ops = {
+static const struct sysfs_ops edd_attr_ops = {
 	.show = edd_attr_show,
 };
 
diff -urNp linux-2.6.32.24/drivers/firmware/efivars.c linux-2.6.32.24/drivers/firmware/efivars.c
--- linux-2.6.32.24/drivers/firmware/efivars.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/firmware/efivars.c	2010-09-04 15:54:52.000000000 -0400
@@ -362,7 +362,7 @@ static ssize_t efivar_attr_store(struct 
 	return ret;
 }
 
-static struct sysfs_ops efivar_attr_ops = {
+static const struct sysfs_ops efivar_attr_ops = {
 	.show = efivar_attr_show,
 	.store = efivar_attr_store,
 };
diff -urNp linux-2.6.32.24/drivers/firmware/iscsi_ibft.c linux-2.6.32.24/drivers/firmware/iscsi_ibft.c
--- linux-2.6.32.24/drivers/firmware/iscsi_ibft.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/firmware/iscsi_ibft.c	2010-09-04 15:54:52.000000000 -0400
@@ -525,7 +525,7 @@ static ssize_t ibft_show_attribute(struc
 	return ret;
 }
 
-static struct sysfs_ops ibft_attr_ops = {
+static const struct sysfs_ops ibft_attr_ops = {
 	.show = ibft_show_attribute,
 };
 
diff -urNp linux-2.6.32.24/drivers/firmware/memmap.c linux-2.6.32.24/drivers/firmware/memmap.c
--- linux-2.6.32.24/drivers/firmware/memmap.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/firmware/memmap.c	2010-09-04 15:54:52.000000000 -0400
@@ -74,7 +74,7 @@ static struct attribute *def_attrs[] = {
 	NULL
 };
 
-static struct sysfs_ops memmap_attr_ops = {
+static const struct sysfs_ops memmap_attr_ops = {
 	.show = memmap_attr_show,
 };
 
diff -urNp linux-2.6.32.24/drivers/gpu/drm/drm_drv.c linux-2.6.32.24/drivers/gpu/drm/drm_drv.c
--- linux-2.6.32.24/drivers/gpu/drm/drm_drv.c	2010-08-29 21:08:20.000000000 -0400
+++ linux-2.6.32.24/drivers/gpu/drm/drm_drv.c	2010-09-04 15:54:52.000000000 -0400
@@ -417,7 +417,7 @@ int drm_ioctl(struct inode *inode, struc
 	char *kdata = NULL;
 
 	atomic_inc(&dev->ioctl_count);
-	atomic_inc(&dev->counts[_DRM_STAT_IOCTLS]);
+	atomic_inc_unchecked(&dev->counts[_DRM_STAT_IOCTLS]);
 	++file_priv->ioctl_count;
 
 	DRM_DEBUG("pid=%d, cmd=0x%02x, nr=0x%02x, dev 0x%lx, auth=%d\n",
diff -urNp linux-2.6.32.24/drivers/gpu/drm/drm_fops.c linux-2.6.32.24/drivers/gpu/drm/drm_fops.c
--- linux-2.6.32.24/drivers/gpu/drm/drm_fops.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/gpu/drm/drm_fops.c	2010-09-04 15:54:52.000000000 -0400
@@ -66,7 +66,7 @@ static int drm_setup(struct drm_device *
 	}
 
 	for (i = 0; i < ARRAY_SIZE(dev->counts); i++)
-		atomic_set(&dev->counts[i], 0);
+		atomic_set_unchecked(&dev->counts[i], 0);
 
 	dev->sigdata.lock = NULL;
 
@@ -130,9 +130,9 @@ int drm_open(struct inode *inode, struct
 
 	retcode = drm_open_helper(inode, filp, dev);
 	if (!retcode) {
-		atomic_inc(&dev->counts[_DRM_STAT_OPENS]);
+		atomic_inc_unchecked(&dev->counts[_DRM_STAT_OPENS]);
 		spin_lock(&dev->count_lock);
-		if (!dev->open_count++) {
+		if (atomic_inc_return(&dev->open_count) == 1) {
 			spin_unlock(&dev->count_lock);
 			retcode = drm_setup(dev);
 			goto out;
@@ -435,7 +435,7 @@ int drm_release(struct inode *inode, str
 
 	lock_kernel();
 
-	DRM_DEBUG("open_count = %d\n", dev->open_count);
+	DRM_DEBUG("open_count = %d\n", atomic_read(&dev->open_count));
 
 	if (dev->driver->preclose)
 		dev->driver->preclose(dev, file_priv);
@@ -447,7 +447,7 @@ int drm_release(struct inode *inode, str
 	DRM_DEBUG("pid = %d, device = 0x%lx, open_count = %d\n",
 		  task_pid_nr(current),
 		  (long)old_encode_dev(file_priv->minor->device),
-		  dev->open_count);
+		  atomic_read(&dev->open_count));
 
 	/* if the master has gone away we can't do anything with the lock */
 	if (file_priv->minor->master)
@@ -524,9 +524,9 @@ int drm_release(struct inode *inode, str
 	 * End inline drm_release
 	 */
 
-	atomic_inc(&dev->counts[_DRM_STAT_CLOSES]);
+	atomic_inc_unchecked(&dev->counts[_DRM_STAT_CLOSES]);
 	spin_lock(&dev->count_lock);
-	if (!--dev->open_count) {
+	if (atomic_dec_and_test(&dev->open_count)) {
 		if (atomic_read(&dev->ioctl_count)) {
 			DRM_ERROR("Device busy: %d\n",
 				  atomic_read(&dev->ioctl_count));
diff -urNp linux-2.6.32.24/drivers/gpu/drm/drm_ioctl.c linux-2.6.32.24/drivers/gpu/drm/drm_ioctl.c
--- linux-2.6.32.24/drivers/gpu/drm/drm_ioctl.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/gpu/drm/drm_ioctl.c	2010-09-04 15:54:52.000000000 -0400
@@ -283,7 +283,7 @@ int drm_getstats(struct drm_device *dev,
 			stats->data[i].value =
 			    (file_priv->master->lock.hw_lock ? file_priv->master->lock.hw_lock->lock : 0);
 		else
-			stats->data[i].value = atomic_read(&dev->counts[i]);
+			stats->data[i].value = atomic_read_unchecked(&dev->counts[i]);
 		stats->data[i].type = dev->types[i];
 	}
 
diff -urNp linux-2.6.32.24/drivers/gpu/drm/drm_lock.c linux-2.6.32.24/drivers/gpu/drm/drm_lock.c
--- linux-2.6.32.24/drivers/gpu/drm/drm_lock.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/gpu/drm/drm_lock.c	2010-09-04 15:54:52.000000000 -0400
@@ -87,7 +87,7 @@ int drm_lock(struct drm_device *dev, voi
 		if (drm_lock_take(&master->lock, lock->context)) {
 			master->lock.file_priv = file_priv;
 			master->lock.lock_time = jiffies;
-			atomic_inc(&dev->counts[_DRM_STAT_LOCKS]);
+			atomic_inc_unchecked(&dev->counts[_DRM_STAT_LOCKS]);
 			break;	/* Got lock */
 		}
 
@@ -165,7 +165,7 @@ int drm_unlock(struct drm_device *dev, v
 		return -EINVAL;
 	}
 
-	atomic_inc(&dev->counts[_DRM_STAT_UNLOCKS]);
+	atomic_inc_unchecked(&dev->counts[_DRM_STAT_UNLOCKS]);
 
 	/* kernel_context_switch isn't used by any of the x86 drm
 	 * modules but is required by the Sparc driver.
diff -urNp linux-2.6.32.24/drivers/gpu/drm/i810/i810_dma.c linux-2.6.32.24/drivers/gpu/drm/i810/i810_dma.c
--- linux-2.6.32.24/drivers/gpu/drm/i810/i810_dma.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/gpu/drm/i810/i810_dma.c	2010-09-04 15:54:52.000000000 -0400
@@ -952,8 +952,8 @@ static int i810_dma_vertex(struct drm_de
 				 dma->buflist[vertex->idx],
 				 vertex->discard, vertex->used);
 
-	atomic_add(vertex->used, &dev->counts[_DRM_STAT_SECONDARY]);
-	atomic_inc(&dev->counts[_DRM_STAT_DMA]);
+	atomic_add_unchecked(vertex->used, &dev->counts[_DRM_STAT_SECONDARY]);
+	atomic_inc_unchecked(&dev->counts[_DRM_STAT_DMA]);
 	sarea_priv->last_enqueue = dev_priv->counter - 1;
 	sarea_priv->last_dispatch = (int)hw_status[5];
 
@@ -1115,8 +1115,8 @@ static int i810_dma_mc(struct drm_device
 	i810_dma_dispatch_mc(dev, dma->buflist[mc->idx], mc->used,
 			     mc->last_render);
 
-	atomic_add(mc->used, &dev->counts[_DRM_STAT_SECONDARY]);
-	atomic_inc(&dev->counts[_DRM_STAT_DMA]);
+	atomic_add_unchecked(mc->used, &dev->counts[_DRM_STAT_SECONDARY]);
+	atomic_inc_unchecked(&dev->counts[_DRM_STAT_DMA]);
 	sarea_priv->last_enqueue = dev_priv->counter - 1;
 	sarea_priv->last_dispatch = (int)hw_status[5];
 
diff -urNp linux-2.6.32.24/drivers/gpu/drm/i915/dvo_ch7017.c linux-2.6.32.24/drivers/gpu/drm/i915/dvo_ch7017.c
--- linux-2.6.32.24/drivers/gpu/drm/i915/dvo_ch7017.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/gpu/drm/i915/dvo_ch7017.c	2010-09-04 15:54:52.000000000 -0400
@@ -443,7 +443,7 @@ static void ch7017_destroy(struct intel_
 	}
 }
 
-struct intel_dvo_dev_ops ch7017_ops = {
+const struct intel_dvo_dev_ops ch7017_ops = {
 	.init = ch7017_init,
 	.detect = ch7017_detect,
 	.mode_valid = ch7017_mode_valid,
diff -urNp linux-2.6.32.24/drivers/gpu/drm/i915/dvo_ch7xxx.c linux-2.6.32.24/drivers/gpu/drm/i915/dvo_ch7xxx.c
--- linux-2.6.32.24/drivers/gpu/drm/i915/dvo_ch7xxx.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/gpu/drm/i915/dvo_ch7xxx.c	2010-09-04 15:54:52.000000000 -0400
@@ -356,7 +356,7 @@ static void ch7xxx_destroy(struct intel_
 	}
 }
 
-struct intel_dvo_dev_ops ch7xxx_ops = {
+const struct intel_dvo_dev_ops ch7xxx_ops = {
 	.init = ch7xxx_init,
 	.detect = ch7xxx_detect,
 	.mode_valid = ch7xxx_mode_valid,
diff -urNp linux-2.6.32.24/drivers/gpu/drm/i915/dvo.h linux-2.6.32.24/drivers/gpu/drm/i915/dvo.h
--- linux-2.6.32.24/drivers/gpu/drm/i915/dvo.h	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/gpu/drm/i915/dvo.h	2010-09-04 15:54:52.000000000 -0400
@@ -135,23 +135,23 @@ struct intel_dvo_dev_ops {
 	 *
 	 * \return singly-linked list of modes or NULL if no modes found.
 	 */
-	struct drm_display_mode *(*get_modes)(struct intel_dvo_device *dvo);
+	struct drm_display_mode *(* const get_modes)(struct intel_dvo_device *dvo);
 
 	/**
 	 * Clean up driver-specific bits of the output
 	 */
-	void (*destroy) (struct intel_dvo_device *dvo);
+	void (* const destroy) (struct intel_dvo_device *dvo);
 
 	/**
 	 * Debugging hook to dump device registers to log file
 	 */
-	void (*dump_regs)(struct intel_dvo_device *dvo);
+	void (* const dump_regs)(struct intel_dvo_device *dvo);
 };
 
-extern struct intel_dvo_dev_ops sil164_ops;
-extern struct intel_dvo_dev_ops ch7xxx_ops;
-extern struct intel_dvo_dev_ops ivch_ops;
-extern struct intel_dvo_dev_ops tfp410_ops;
-extern struct intel_dvo_dev_ops ch7017_ops;
+extern const struct intel_dvo_dev_ops sil164_ops;
+extern const struct intel_dvo_dev_ops ch7xxx_ops;
+extern const struct intel_dvo_dev_ops ivch_ops;
+extern const struct intel_dvo_dev_ops tfp410_ops;
+extern const struct intel_dvo_dev_ops ch7017_ops;
 
 #endif /* _INTEL_DVO_H */
diff -urNp linux-2.6.32.24/drivers/gpu/drm/i915/dvo_ivch.c linux-2.6.32.24/drivers/gpu/drm/i915/dvo_ivch.c
--- linux-2.6.32.24/drivers/gpu/drm/i915/dvo_ivch.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/gpu/drm/i915/dvo_ivch.c	2010-09-04 15:54:52.000000000 -0400
@@ -430,7 +430,7 @@ static void ivch_destroy(struct intel_dv
 	}
 }
 
-struct intel_dvo_dev_ops ivch_ops= {
+const struct intel_dvo_dev_ops ivch_ops= {
 	.init = ivch_init,
 	.dpms = ivch_dpms,
 	.save = ivch_save,
diff -urNp linux-2.6.32.24/drivers/gpu/drm/i915/dvo_sil164.c linux-2.6.32.24/drivers/gpu/drm/i915/dvo_sil164.c
--- linux-2.6.32.24/drivers/gpu/drm/i915/dvo_sil164.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/gpu/drm/i915/dvo_sil164.c	2010-09-04 15:54:52.000000000 -0400
@@ -290,7 +290,7 @@ static void sil164_destroy(struct intel_
 	}
 }
 
-struct intel_dvo_dev_ops sil164_ops = {
+const struct intel_dvo_dev_ops sil164_ops = {
 	.init = sil164_init,
 	.detect = sil164_detect,
 	.mode_valid = sil164_mode_valid,
diff -urNp linux-2.6.32.24/drivers/gpu/drm/i915/dvo_tfp410.c linux-2.6.32.24/drivers/gpu/drm/i915/dvo_tfp410.c
--- linux-2.6.32.24/drivers/gpu/drm/i915/dvo_tfp410.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/gpu/drm/i915/dvo_tfp410.c	2010-09-04 15:54:52.000000000 -0400
@@ -323,7 +323,7 @@ static void tfp410_destroy(struct intel_
 	}
 }
 
-struct intel_dvo_dev_ops tfp410_ops = {
+const struct intel_dvo_dev_ops tfp410_ops = {
 	.init = tfp410_init,
 	.detect = tfp410_detect,
 	.mode_valid = tfp410_mode_valid,
diff -urNp linux-2.6.32.24/drivers/gpu/drm/i915/i915_drv.c linux-2.6.32.24/drivers/gpu/drm/i915/i915_drv.c
--- linux-2.6.32.24/drivers/gpu/drm/i915/i915_drv.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/gpu/drm/i915/i915_drv.c	2010-09-04 15:54:52.000000000 -0400
@@ -285,7 +285,7 @@ i915_pci_resume(struct pci_dev *pdev)
 	return i915_resume(dev);
 }
 
-static struct vm_operations_struct i915_gem_vm_ops = {
+static const struct vm_operations_struct i915_gem_vm_ops = {
 	.fault = i915_gem_fault,
 	.open = drm_gem_vm_open,
 	.close = drm_gem_vm_close,
diff -urNp linux-2.6.32.24/drivers/gpu/drm/i915/i915_gem.c linux-2.6.32.24/drivers/gpu/drm/i915/i915_gem.c
--- linux-2.6.32.24/drivers/gpu/drm/i915/i915_gem.c	2010-09-20 17:26:42.000000000 -0400
+++ linux-2.6.32.24/drivers/gpu/drm/i915/i915_gem.c	2010-09-28 18:22:42.000000000 -0400
@@ -492,6 +492,11 @@ i915_gem_pread_ioctl(struct drm_device *
 		return -EINVAL;
 	}
 
+	if (!access_ok(VERIFY_WRITE, (char __user *) (uintptr_t)args->data_ptr, args->size)) {
+		drm_gem_object_unreference(obj);
+		return -EFAULT;
+	}
+
 	if (i915_gem_object_needs_bit17_swizzle(obj)) {
 		ret = i915_gem_shmem_pread_slow(dev, obj, args, file_priv);
 	} else {
@@ -965,6 +970,11 @@ i915_gem_pwrite_ioctl(struct drm_device 
 		return -EINVAL;
 	}
 
+	if (!access_ok(VERIFY_READ, (char __user *) (uintptr_t)args->data_ptr, args->size)) {
+		drm_gem_object_unreference(obj);
+		return -EFAULT;
+	}
+
 	/* We can only do the GTT pwrite on untiled buffers, as otherwise
 	 * it would end up going through the fenced access, and we'll get
 	 * different detiling behavior between reading and writing.
diff -urNp linux-2.6.32.24/drivers/gpu/drm/radeon/mkregtable.c linux-2.6.32.24/drivers/gpu/drm/radeon/mkregtable.c
--- linux-2.6.32.24/drivers/gpu/drm/radeon/mkregtable.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/gpu/drm/radeon/mkregtable.c	2010-09-04 15:54:52.000000000 -0400
@@ -637,14 +637,14 @@ static int parser_auth(struct table *t, 
 	regex_t mask_rex;
 	regmatch_t match[4];
 	char buf[1024];
-	size_t end;
+	long end;
 	int len;
 	int done = 0;
 	int r;
 	unsigned o;
 	struct offset *offset;
 	char last_reg_s[10];
-	int last_reg;
+	unsigned long last_reg;
 
 	if (regcomp
 	    (&mask_rex, "(0x[0-9a-fA-F]*) *([_a-zA-Z0-9]*)", REG_EXTENDED)) {
